import 'package:daggerito/daggerito.dart';

import '../dependency_container.dart';

class Component {
  final DependencyContainer container;

  Component({
    List<Module> modules = const [],
    bool silent,
    DependencyContainer container,
    bool registerSelf = true,
  }) : this.container = container ??
      DependencyContainer(
        silent: silent,
      ) {
    if (registerSelf) {
      this.container.registerInstance(this, as: Component);
    }
    modules.forEach(
          (module) => module.register(this.container),
    );
  }

  T call<T>([String tag]) => container.resolve<T>(tag);

  void replaceAndRegisterInstance<T>(T value, [String tag]) {
    DependencyContainer container = this.container.has<T>(tag) ? this.container
        .unregister<T>(tag) : this.container;
    container.registerInstance(value);
  }
}
